<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CCodeRefactoring: searchPathUtilities.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CCodeRefactoring
   &#160;<span id="projectnumber">First Alpha</span>
   </div>
   <div id="projectbrief">Create Simulation Executable From Existing Code</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('search_path_utilities_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">searchPathUtilities.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="search_path_utilities_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;dirent.h&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;errno.h&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;iomanip&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef IDSTRUCT</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">    #define IDSTRUCT</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;{   </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    std::string childKey;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    std::string childIndex;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    std::string propertyIndex;   </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    std::string featureID;           </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;} <a class="code" href="structident__type.html">ident_type</a>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">   25</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(<span class="keyword">const</span> std::string&amp; str, std::vector&lt;std::string&gt;&amp; cont,<span class="keywordtype">char</span> delim)</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;{</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    std::size_t current, previous = 0;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    current = str.find(delim);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordflow">while</span> (current != std::string::npos) {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        cont.push_back(str.substr(previous, current - previous));</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        previous = current + 1;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        current = str.find(delim, previous);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    }</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    cont.push_back(str.substr(previous, current - previous));</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;}</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a4731041361b0df9f731e6f0d9dcb2037">   37</a></span>&#160;std::string <a class="code" href="search_path_utilities_8hpp.html#a4731041361b0df9f731e6f0d9dcb2037">cutleadingNtrailingPattern</a>(std::string search_path,std::string pattern)</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;   std::string result;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;   std::size_t found_0 = search_path.find(pattern);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordflow">if</span> (found_0!=std::string::npos)</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        std::size_t found_1=search_path.find(pattern,found_0+1);    </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        std::size_t len =found_1-(found_0+1);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        result= search_path.substr(found_0+1,len);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    }</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;}</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a65385cf4429f17bcbd1f4e78c4d50259">   50</a></span>&#160;std::string <a class="code" href="search_path_utilities_8hpp.html#a65385cf4429f17bcbd1f4e78c4d50259">replaceString</a>(std::string search_path,std::string origin,std::string replacement)</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;{   </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;   std::size_t found = search_path.find(origin);   </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;   std::size_t len = origin.length();</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">if</span> (found!=std::string::npos)</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    {</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        std::string front = search_path.substr(0,found);</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        std::string back = search_path.substr(found+len);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        search_path = front + replacement + back;        </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    }</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  <span class="keywordflow">return</span> search_path;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a4f05a8edd34e9bcd7e5ad6574dfb1747">   63</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="search_path_utilities_8hpp.html#a4f05a8edd34e9bcd7e5ad6574dfb1747">isSpace</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> c) {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordflow">return</span> (c == <span class="charliteral">&#39; &#39;</span> || c == <span class="charliteral">&#39;\n&#39;</span> || c == <span class="charliteral">&#39;\r&#39;</span> ||</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        c == <span class="charliteral">&#39;\t&#39;</span> || c == <span class="charliteral">&#39;\v&#39;</span> || c == <span class="charliteral">&#39;\f&#39;</span>);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;}</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a5b17eb6620c1c79a216b45cb08364b20">   68</a></span>&#160;std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; <a class="code" href="search_path_utilities_8hpp.html#a5b17eb6620c1c79a216b45cb08364b20">getElementOfJSONChainedDoc</a>(std::string JSONDocs)</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;{</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    std::vector&lt;std::string&gt; result_vec;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    std::size_t found_b = JSONDocs.find_first_of(<span class="stringliteral">&quot;{&quot;</span>);</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    std::size_t found_e = JSONDocs.find_last_of(<span class="stringliteral">&quot;}&quot;</span>);</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    std::string res_ini;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordflow">if</span>(found_b!=std::string::npos &amp;&amp; found_e!=std::string::npos)</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        res_ini = JSONDocs.substr(found_b+1,found_e-1);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    }</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    </div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    std::vector&lt;std::string&gt; res_vec;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    std::size_t found_b_com;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordflow">while</span>(<span class="keyword">true</span>)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        found_b_com = res_ini.find_first_of(<span class="stringliteral">&quot;,&quot;</span>);    </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">if</span>(found_b_com!=std::string::npos)</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        {        </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            std::size_t found_b_bracket = res_ini.find_first_of(<span class="stringliteral">&quot;[&quot;</span>);    </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            <span class="keywordflow">if</span>(found_b_bracket!=std::string::npos &amp;&amp; found_b_bracket &lt; found_b_com)</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            {</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;                found_b_bracket = res_ini.find_first_of(<span class="stringliteral">&quot;]&quot;</span>);    </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;                res_vec.push_back(res_ini.substr(0,found_b_bracket+1));</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;                res_ini=res_ini.substr(found_b_bracket+1);</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;                found_b_com = res_ini.find_first_of(<span class="stringliteral">&quot;,&quot;</span>);</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;            }</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            {</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                res_vec.push_back(res_ini.substr(0,found_b_com-1));    </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            }            </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            res_ini=res_ini.substr(found_b_com+1);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        }</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        {</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            std::size_t found_e_bracket = res_ini.find_last_of(<span class="stringliteral">&quot;]&quot;</span>);   </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            res_vec.push_back(res_ini.substr(0,found_e_bracket-1));     </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        }</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    }</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;   </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; pair_vec;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator it = res_vec.begin();it != res_vec.end();it++)</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        std::string cur = *it;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        std::vector&lt;std::string&gt; keyval_vec;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        std::pair&lt;std::string,std::string&gt; cur_pair;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(cur,keyval_vec,<span class="charliteral">&#39;:&#39;</span>);    </div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordflow">while</span>(<span class="keyword">true</span>)</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        {</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            std::size_t found = keyval_vec[0].find(<span class="charliteral">&#39;\&quot;&#39;</span>);    </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            <span class="keywordflow">if</span>(found==std::string::npos)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            }</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            keyval_vec[0].erase(found,1);</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        }       </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        keyval_vec[0].erase(std::remove_if(keyval_vec[0].begin(), keyval_vec[0].end(), <a class="code" href="search_path_utilities_8hpp.html#a4f05a8edd34e9bcd7e5ad6574dfb1747">isSpace</a>), keyval_vec[0].end());</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        cur_pair.first = keyval_vec[0];        </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        std::size_t found_b_bracket_start = cur.find_first_of(<span class="stringliteral">&quot;[&quot;</span>);            </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        std::size_t found_b_bracket_end = cur.find_first_of(<span class="stringliteral">&quot;]&quot;</span>);            </div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keywordflow">if</span>(found_b_bracket_start!=std::string::npos &amp;&amp; found_b_bracket_end!=std::string::npos)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            std::string raw = cur.substr(found_b_bracket_start,found_b_bracket_end+1);</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                        </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            <span class="keywordflow">while</span>(<span class="keyword">true</span>)</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            {</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;                std::size_t found = raw.find(<span class="charliteral">&#39;\&quot;&#39;</span>);    </div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;                <span class="keywordflow">if</span>(found==std::string::npos)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;                {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                raw.erase(found,1);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            }</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            raw.erase(std::remove_if(raw.begin(), raw.end(), <a class="code" href="search_path_utilities_8hpp.html#a4f05a8edd34e9bcd7e5ad6574dfb1747">isSpace</a>), raw.end());</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;            cur_pair.second = raw;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        }</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        {            </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            <span class="keywordflow">while</span>(<span class="keyword">true</span>)</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            {</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;                std::size_t found = keyval_vec[1].find(<span class="charliteral">&#39;\&quot;&#39;</span>);    </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;                <span class="keywordflow">if</span>(found==std::string::npos)</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;                {</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                }</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                keyval_vec[1].erase(found,1);</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;            }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;            keyval_vec[1].erase(std::remove_if(keyval_vec[1].begin(), keyval_vec[1].end(), <a class="code" href="search_path_utilities_8hpp.html#a4f05a8edd34e9bcd7e5ad6574dfb1747">isSpace</a>), keyval_vec[1].end());</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            cur_pair.second = keyval_vec[1];                        </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        }        </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        pair_vec.push_back(cur_pair);</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    }</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160; </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordflow">return</span> pair_vec;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;}</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160; </div>
<div class="line"><a name="l00169"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a22aa9d16f96c6693a4997b3c37d9c134">  169</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="search_path_utilities_8hpp.html#a22aa9d16f96c6693a4997b3c37d9c134">getElementOfJSONAppendedDoc</a>(std::string JSONDocs)</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;{</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    std::vector&lt;std::string&gt; result_vec;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    std::vector&lt;std::string&gt; res;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(JSONDocs, res,<span class="charliteral">&#39;{&#39;</span>);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    std::vector&lt;std::string&gt; res1; </div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res[1], res1,<span class="charliteral">&#39;}&#39;</span>);</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    std::vector&lt;std::string&gt; res2; </div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res1[0], res2,<span class="charliteral">&#39;,&#39;</span>);</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                </div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> rIt=0;rIt&lt;res2.size();rIt++)</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    {</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        std::vector&lt;std::string&gt; res3; </div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res2[rIt], res3,<span class="charliteral">&#39;:&#39;</span>);                   </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        std::vector&lt;std::string&gt; res4; </div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res3[1], res4,<span class="charliteral">&#39;\&quot;&#39;</span>);                                        </div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        result_vec.push_back(res4[1]);            </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    }      </div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keywordflow">return</span> result_vec;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;}</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160; </div>
<div class="line"><a name="l00190"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a7ea64e50cd40d9c0b921a481e718740f">  190</a></span>&#160;std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; <a class="code" href="search_path_utilities_8hpp.html#a7ea64e50cd40d9c0b921a481e718740f">getElementPairsOfJSONArray</a>(std::string JSONarray)</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;{</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; result_vec;    </div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    std::vector&lt;std::string&gt; res;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(JSONarray, res,<span class="charliteral">&#39;[&#39;</span>);</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    std::vector&lt;std::string&gt; res1; </div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res[1], res1,<span class="charliteral">&#39;]&#39;</span>);</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    std::vector&lt;std::string&gt; res2; </div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res1[0], res2,<span class="charliteral">&#39;,&#39;</span>);</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> rIt=0;rIt&lt;res2.size();rIt++)</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    {</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        std::pair&lt;std::string,std::string&gt; pair;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        std::vector&lt;std::string&gt; res3; </div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res2[rIt], res3,<span class="charliteral">&#39;:&#39;</span>);                   </div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        std::vector&lt;std::string&gt; res4; </div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res3[1], res4,<span class="charliteral">&#39;}&#39;</span>);   </div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        std::vector&lt;std::string&gt; res5;         </div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        pair.second = res4[0];                    </div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res3[0], res5,<span class="charliteral">&#39;{&#39;</span>);           </div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        pair.first = res5[1];    </div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        result_vec.push_back(pair);</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    }      </div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <span class="keywordflow">return</span> result_vec;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;}</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160; </div>
<div class="line"><a name="l00216"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a38a14ece7625a78b944e2fcdf17ef45b">  216</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="search_path_utilities_8hpp.html#a38a14ece7625a78b944e2fcdf17ef45b">getElementOfJSONArray</a>(std::string JSONarray)</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;{</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    std::vector&lt;std::string&gt; result_vec;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    std::vector&lt;std::string&gt; res;</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(JSONarray, res,<span class="charliteral">&#39;[&#39;</span>);</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    std::vector&lt;std::string&gt; res1; </div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res[1], res1,<span class="charliteral">&#39;]&#39;</span>);</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    std::vector&lt;std::string&gt; res2; </div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res1[0], res2,<span class="charliteral">&#39;,&#39;</span>);</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                </div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> rIt=0;rIt&lt;res2.size();rIt++)</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    {</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        std::vector&lt;std::string&gt; res3; </div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res2[rIt], res3,<span class="charliteral">&#39;:&#39;</span>);                   </div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        std::vector&lt;std::string&gt; res4; </div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res3[1], res4,<span class="charliteral">&#39;}&#39;</span>);   </div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        std::vector&lt;std::string&gt; res5; </div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res4[0], res5,<span class="charliteral">&#39;\&quot;&#39;</span>);                                       </div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        result_vec.push_back(res5[1]);            </div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    }      </div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <span class="keywordflow">return</span> result_vec;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;}</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160; </div>
<div class="line"><a name="l00239"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a05bc4046e38ba530ba7c938105aed5a4">  239</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="search_path_utilities_8hpp.html#a05bc4046e38ba530ba7c938105aed5a4">checkNcreateDirectories</a>(std::string targetFile,std::string sourceFileFullPath)</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;{</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <span class="keyword">using</span> llvm::Twine;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    </div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    std::size_t found = targetFile.find_last_of(<span class="stringliteral">&quot;/\\&quot;</span>);</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    std::string targetDir = targetFile.substr(0,found);                                    </div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    std::vector&lt;std::string&gt; trgtsplit;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(targetDir, trgtsplit,<span class="charliteral">&#39;/&#39;</span>);                                    </div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    llvm::StringRef CachePath(<span class="stringliteral">&quot;/usr/src/&quot;</span>); </div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    std::string trgtStr;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> trgIt=0;trgIt&lt;trgtsplit.size();trgIt++)                                                                                  </div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    {</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keywordflow">if</span>(!trgtsplit[trgIt].empty())</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        {</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;            trgtStr+=<span class="stringliteral">&quot;/&quot;</span>+trgtsplit[trgIt];         </div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;            std::error_code EC;   </div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            <span class="keywordtype">bool</span> b_found = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            <span class="keywordflow">for</span> (llvm::sys::fs::recursive_directory_iterator DirIt(CachePath, EC), DirEnd; DirIt != DirEnd &amp;&amp; !EC; DirIt.increment(EC))                                                                          </div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            {</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                llvm::StringRef FilePath(DirIt-&gt;path());</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;                <span class="keywordflow">if</span>(DirIt-&gt;path().find(trgtStr)!=std::string::npos)</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                {                    </div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;                    b_found = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                    <span class="keywordflow">break</span>;                                                </div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                }                                        </div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;            }</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            <span class="keywordflow">if</span>(!b_found)</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            {</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;                std::error_code ECDir = llvm::sys::fs::create_directory(Twine(trgtStr));                                                                </div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            }</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        }</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    }      </div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    std::error_code ECFlCpy = llvm::sys::fs::copy_file(Twine(sourceFileFullPath),Twine(targetFile)); </div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;}</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160; </div>
<div class="line"><a name="l00274"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a6eaa9e7803d69414d32130fee3c26789">  274</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="search_path_utilities_8hpp.html#a6eaa9e7803d69414d32130fee3c26789">createTargetFilePath</a>(std::string sourceFileJson)</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;{</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    std::vector&lt;std::string&gt; result;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160; </div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    std::string sourceFileFullPath;</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    std::string targetFile;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160; </div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    std::vector&lt;std::string&gt; res_h;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(sourceFileJson, res_h,<span class="charliteral">&#39;:&#39;</span>);</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    std::vector&lt;std::string&gt; res_h1;</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res_h[1], res_h1,<span class="charliteral">&#39;\&quot;&#39;</span>);                                    </div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    std::size_t found = res_h1[1].find_last_of(<span class="stringliteral">&quot;/\\&quot;</span>);</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    </div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordflow">if</span> (found!=std::string::npos)</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    {</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        sourceFileFullPath = res_h1[1];      </div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        std::vector&lt;std::string&gt; res_hsplit;                                </div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(res_h1[1], res_hsplit,<span class="charliteral">&#39;/&#39;</span>);        </div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> hIter=0;hIter&lt;res_hsplit.size();hIter++)</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        {</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            <span class="keywordflow">if</span>(res_hsplit[hIter].compare(<span class="stringliteral">&quot;sw_to_analyze&quot;</span>)==0)</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            {</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;                targetFile+=<span class="stringliteral">&quot;/sw_to_build&quot;</span>;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            }</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span>(res_hsplit[hIter].empty())</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            {</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;                <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            }</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            {</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                targetFile+=<span class="stringliteral">&quot;/&quot;</span>+res_hsplit[hIter];</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;            }</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        }</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    }</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160; </div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    result.push_back(sourceFileFullPath);</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    result.push_back(targetFile);</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160; </div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    found = targetFile.find_last_of(<span class="stringliteral">&quot;/\\&quot;</span>);</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160; </div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <span class="keywordflow">if</span>(found)</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    {</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        result.push_back(targetFile.substr(0,found));    </div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    }</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    </div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160; </div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;}</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160; </div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160; </div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160; </div>
<div class="line"><a name="l00325"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a152e2fff4bde021a57705e981df39a17">  325</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="search_path_utilities_8hpp.html#a152e2fff4bde021a57705e981df39a17">createTargetFileNDirectory</a>(std::string targetfileJSON)</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;{</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    std::vector&lt;std::string&gt; result = <a class="code" href="search_path_utilities_8hpp.html#a6eaa9e7803d69414d32130fee3c26789">createTargetFilePath</a>(targetfileJSON);</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    std::string sourceFileFullPath = result[0];</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    std::string targetFile = result[1];</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    std::size_t found = targetFile.find_last_of(<span class="stringliteral">&quot;/\\&quot;</span>);</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <span class="keywordflow">if</span> (found!=std::string::npos)</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    {                         </div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#a05bc4046e38ba530ba7c938105aed5a4">checkNcreateDirectories</a>(targetFile,sourceFileFullPath);                 </div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    }     </div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;}</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160; </div>
<div class="line"><a name="l00338"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a6f7bdad1724b71001c5dd5c9b6d989bd">  338</a></span>&#160;std::vector&lt;std::vector&lt;std::string&gt;&gt; <a class="code" href="search_path_utilities_8hpp.html#a6f7bdad1724b71001c5dd5c9b6d989bd">createWorkingEnvironment</a>()</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;{</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    std::vector&lt;std::vector&lt;std::string&gt;&gt; result;</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    std::vector&lt;std::string&gt; C_filepaths;</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    std::vector&lt;std::string&gt; H_dirpaths;</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;                                               </div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    std::vector&lt;std::vector&lt;std::string&gt;&gt; header_vec_vec = <a class="code" href="postgres_interface_8hpp.html#abb99b0e2add80b662e70fc70543569d8">getStringVectorFromJsonObj</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;headertree&quot;</span>,<span class="stringliteral">&quot;hdrtree&quot;</span>);</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;                                                </div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> iv=0;iv&lt;header_vec_vec.size();iv++)</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    {</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;        std::vector&lt;std::string&gt; res;</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        <a class="code" href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a>(header_vec_vec[iv][0], res,<span class="charliteral">&#39;,&#39;</span>);</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> res_i=0;res_i&lt;res.size();res_i++)                          </div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;        {</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;            std::size_t found = res[res_i].find(<span class="stringliteral">&quot;\&quot;Header\&quot;&quot;</span>);</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;            <span class="keywordflow">if</span> (found!=std::string::npos)</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;            {</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;                std::vector&lt;std::string&gt; res_vec = <a class="code" href="search_path_utilities_8hpp.html#a152e2fff4bde021a57705e981df39a17">createTargetFileNDirectory</a>(res[res_i]);</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;                H_dirpaths.push_back(res_vec[2]);</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;            }</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;            found = res[res_i].find(<span class="stringliteral">&quot;\&quot;CFile\&quot;&quot;</span>);</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;            <span class="keywordflow">if</span> (found!=std::string::npos)</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;            {</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;                std::vector&lt;std::string&gt; res_vec = <a class="code" href="search_path_utilities_8hpp.html#a152e2fff4bde021a57705e981df39a17">createTargetFileNDirectory</a>(res[res_i]);</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160; </div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;                <span class="keyword">using</span> llvm::Twine;</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;                std::string trgtCMakePth = res_vec[2] + <span class="stringliteral">&quot;/CMakeLists.txt&quot;</span>;</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;                std::string srcCMakePth = <span class="stringliteral">&quot;/usr/src/app/LinuxSimulationEnv/templates/CMakeListsTmpl.txt&quot;</span>;                                                              </div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;                std::error_code ECFlCpy = llvm::sys::fs::copy_file(Twine(srcCMakePth),Twine(trgtCMakePth)); </div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;                C_filepaths.push_back(res_vec[1]);</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;            }</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        }                            </div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;    }</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160; </div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    std::sort(H_dirpaths.begin(), H_dirpaths.end());</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;    <span class="keyword">auto</span> last = std::unique(H_dirpaths.begin(), H_dirpaths.end());                                </div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    H_dirpaths.erase(last, H_dirpaths.end());</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160; </div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    std::sort(C_filepaths.begin(), C_filepaths.end());</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    last = std::unique(C_filepaths.begin(), C_filepaths.end());                </div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    C_filepaths.erase(last, C_filepaths.end());</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160; </div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    result.push_back(C_filepaths);</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    result.push_back(H_dirpaths);</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160; </div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;}</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160; </div>
<div class="line"><a name="l00386"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a35040d624bbaf96a0baf54d0fffd1f8b">  386</a></span>&#160;<a class="code" href="structident__type.html">ident_type</a> <a class="code" href="search_path_utilities_8hpp.html#a35040d624bbaf96a0baf54d0fffd1f8b">getIdentificationOfObj</a>(std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_inner_vec,std::string key)</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;{</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;    <a class="code" href="structident__type.html">ident_type</a> id;</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;    <span class="keywordtype">bool</span> isChildOfSWVariable = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    <span class="keywordflow">for</span>(std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt;::iterator itVal=val_inner_vec.begin();itVal!=val_inner_vec.end();itVal++)</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;    {                              </div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;        std::pair&lt;std::string,std::string&gt; curVal = *itVal;</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;        std::size_t found = curVal.first.find(<span class="charliteral">&#39;{&#39;</span>);    </div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160; </div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;        <span class="keywordflow">if</span>(isChildOfSWVariable)</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        {</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;            <span class="keywordtype">id</span>.<a class="code" href="structident__type.html#a1e277fd036cb9c74885f72dc7f82289f">childKey</a> = curVal.first;            </div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;            <span class="keywordtype">id</span>.childIndex = curVal.second;</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;            isChildOfSWVariable=<span class="keyword">false</span>;</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;        }                 </div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;        <span class="keywordflow">if</span>(curVal.first.compare(key)==0)</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;        {</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;            <span class="keywordtype">id</span>.propertyIndex = curVal.second;</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;            isChildOfSWVariable = <span class="keyword">true</span>;                           </div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        }                                                     </div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    }</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    <span class="keywordflow">return</span> id;</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;}</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160; </div>
<div class="line"><a name="l00412"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a3a886e5cb3ce1bb6064aeac57f547f72">  412</a></span>&#160;<a class="code" href="structident__type.html">ident_type</a> <a class="code" href="search_path_utilities_8hpp.html#a3a886e5cb3ce1bb6064aeac57f547f72">getIdentificationStruct</a>(std::vector&lt;std::string&gt; cur_vec,std::string key)</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;{</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    <a class="code" href="structident__type.html">ident_type</a> SW_VAR_ID;</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    std::string cur_val = cur_vec[0];</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;            </div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_vec = <a class="code" href="search_path_utilities_8hpp.html#a5b17eb6620c1c79a216b45cb08364b20">getElementOfJSONChainedDoc</a>(cur_val);</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    <span class="keywordflow">for</span>(std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt;::iterator itPr=val_vec.begin();itPr!=val_vec.end();itPr++)</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;    {</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        std::pair&lt;std::string,std::string&gt; curPr = *itPr;</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;        <span class="keywordflow">if</span>(curPr.first.compare(<span class="stringliteral">&quot;hierarchy&quot;</span>)==0)</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;        {                   </div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;            std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_inner_vec = <a class="code" href="search_path_utilities_8hpp.html#a7ea64e50cd40d9c0b921a481e718740f">getElementPairsOfJSONArray</a>(curPr.second);</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;            SW_VAR_ID =  <a class="code" href="search_path_utilities_8hpp.html#a35040d624bbaf96a0baf54d0fffd1f8b">getIdentificationOfObj</a>(val_inner_vec,key);</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;        }                </div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160; </div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        <span class="keywordflow">if</span>(curPr.first.compare(<span class="stringliteral">&quot;identifier&quot;</span>)==0)</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        {</div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;            SW_VAR_ID.<a class="code" href="structident__type.html#aedc0c975bbd5c35d060577c6a06c48cd">featureID</a> = curPr.second;</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;        }            </div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;    }</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;    <span class="keywordflow">return</span> SW_VAR_ID;</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;}</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160; </div>
<div class="line"><a name="l00439"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a8053480525c9fdca9d9feabaf252b90c">  439</a></span>&#160;std::string <a class="code" href="search_path_utilities_8hpp.html#a8053480525c9fdca9d9feabaf252b90c">getSWUnitRef</a>(std::string MDX_methimpl)</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;{</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;    std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_methimpl_vec = <a class="code" href="search_path_utilities_8hpp.html#a5b17eb6620c1c79a216b45cb08364b20">getElementOfJSONChainedDoc</a>(MDX_methimpl);    </div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;    <span class="keywordtype">bool</span> isUnitRef = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;    std::string unit_ref;</div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> k=0;k&lt;val_methimpl_vec.size();k++)</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;    {</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;        <span class="keywordflow">if</span>(val_methimpl_vec[k].second.compare(<span class="stringliteral">&quot;SW-UNIT-REF&quot;</span>)==0)</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;        {</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;            isUnitRef = <span class="keyword">true</span>;                            </div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;        }</div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;        <span class="keywordflow">if</span>(val_methimpl_vec[k].first.compare(<span class="stringliteral">&quot;values&quot;</span>)==0 &amp;&amp; isUnitRef)                        </div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;        {</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;            isUnitRef = <span class="keyword">false</span>;                            </div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;            std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_unit_vec = <a class="code" href="search_path_utilities_8hpp.html#a7ea64e50cd40d9c0b921a481e718740f">getElementPairsOfJSONArray</a>(val_methimpl_vec[k].second);;                                                        </div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;            unit_ref = val_unit_vec[0].second;</div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;        }</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;    }</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    <span class="keywordflow">return</span> unit_ref;</div>
<div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;}</div>
<div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160; </div>
<div class="line"><a name="l00460"></a><span class="lineno"><a class="line" href="search_path_utilities_8hpp.html#a2d2bb888b17259ef2c9d363504c742db">  460</a></span>&#160;std::pair&lt;std::string,std::vector&lt;std::string&gt;&gt; <a class="code" href="search_path_utilities_8hpp.html#a2d2bb888b17259ef2c9d363504c742db">getDenominatorOrNumerator</a>(std::string MDX_methimpl)</div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;{</div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    std::pair&lt;std::string,std::vector&lt;std::string&gt;&gt; result;</div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;    std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_methimpl_vec = <a class="code" href="search_path_utilities_8hpp.html#a5b17eb6620c1c79a216b45cb08364b20">getElementOfJSONChainedDoc</a>(MDX_methimpl);            </div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;    <span class="keywordtype">bool</span> isUnitRef = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;    <span class="keywordtype">bool</span> isDenominator = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;    <span class="keywordtype">bool</span> isNumerator = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;    std::string unit_ref;</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> k=0;k&lt;val_methimpl_vec.size();k++)</div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;    {</div>
<div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;        <span class="keywordflow">if</span>(val_methimpl_vec[k].first.compare(<span class="stringliteral">&quot;hierarchy&quot;</span>)==0)</div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        {</div>
<div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;            std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_unit_vec = <a class="code" href="search_path_utilities_8hpp.html#a7ea64e50cd40d9c0b921a481e718740f">getElementPairsOfJSONArray</a>(val_methimpl_vec[k].second);</div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;            <span class="keywordflow">for</span>(std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt;::iterator it=val_unit_vec.begin();it!=val_unit_vec.end();it++)</div>
<div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;            {</div>
<div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;                std::pair&lt;std::string,std::string&gt; curPair = *it;</div>
<div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;                <span class="keywordflow">if</span>(curPair.first.compare(<span class="stringliteral">&quot;SW-COMPU-DENOMINATOR&quot;</span>)==0)</div>
<div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;                {</div>
<div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;                    isDenominator = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;                    result.first = <span class="stringliteral">&quot;Denominator&quot;</span>;</div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;                }</div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;                <span class="keywordflow">if</span>(curPair.first.compare(<span class="stringliteral">&quot;SW-COMPU-NUMERATOR&quot;</span>)==0)</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;                {</div>
<div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;                    isNumerator = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;                    result.first = <span class="stringliteral">&quot;Numerator&quot;</span>;</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;                }</div>
<div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;            }</div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;        }</div>
<div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;        <span class="keywordflow">if</span>(val_methimpl_vec[k].second.compare(<span class="stringliteral">&quot;VF&quot;</span>)==0)</div>
<div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;        {</div>
<div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;            isUnitRef = <span class="keyword">true</span>;                            </div>
<div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        }</div>
<div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;        </div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        <span class="keywordflow">if</span>(val_methimpl_vec[k].first.compare(<span class="stringliteral">&quot;values&quot;</span>)==0 &amp;&amp; isUnitRef)                        </div>
<div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;        {</div>
<div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;            isUnitRef = <span class="keyword">false</span>;                                        </div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;            std::vector&lt;std::pair&lt;std::string,std::string&gt;&gt; val_unit_vec = <a class="code" href="search_path_utilities_8hpp.html#a7ea64e50cd40d9c0b921a481e718740f">getElementPairsOfJSONArray</a>(val_methimpl_vec[k].second);</div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;            unit_ref = val_unit_vec[0].second;</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;            result.second.push_back(val_unit_vec[0].second);</div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;            result.second.push_back(val_unit_vec[1].second);</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;        }</div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;    }</div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="asearch_path_utilities_8hpp_html_a4f05a8edd34e9bcd7e5ad6574dfb1747"><div class="ttname"><a href="search_path_utilities_8hpp.html#a4f05a8edd34e9bcd7e5ad6574dfb1747">isSpace</a></div><div class="ttdeci">bool isSpace(unsigned char c)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:63</div></div>
<div class="ttc" id="astructident__type_html_a1e277fd036cb9c74885f72dc7f82289f"><div class="ttname"><a href="structident__type.html#a1e277fd036cb9c74885f72dc7f82289f">ident_type::childKey</a></div><div class="ttdeci">std::string childKey</div><div class="ttdef"><b>Definition:</b> resolveInterfaceVariables.hpp:72</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a152e2fff4bde021a57705e981df39a17"><div class="ttname"><a href="search_path_utilities_8hpp.html#a152e2fff4bde021a57705e981df39a17">createTargetFileNDirectory</a></div><div class="ttdeci">std::vector&lt; std::string &gt; createTargetFileNDirectory(std::string targetfileJSON)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:325</div></div>
<div class="ttc" id="apostgres_interface_8hpp_html_abb99b0e2add80b662e70fc70543569d8"><div class="ttname"><a href="postgres_interface_8hpp.html#abb99b0e2add80b662e70fc70543569d8">getStringVectorFromJsonObj</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; std::string &gt; &gt; getStringVectorFromJsonObj(std::string dbName, std::string table, std::string collumn, std::vector&lt; std::string &gt; property=std::vector&lt; std::string &gt;())</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:497</div></div>
<div class="ttc" id="astructident__type_html_aedc0c975bbd5c35d060577c6a06c48cd"><div class="ttname"><a href="structident__type.html#aedc0c975bbd5c35d060577c6a06c48cd">ident_type::featureID</a></div><div class="ttdeci">std::string featureID</div><div class="ttdef"><b>Definition:</b> resolveInterfaceVariables.hpp:75</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a22aa9d16f96c6693a4997b3c37d9c134"><div class="ttname"><a href="search_path_utilities_8hpp.html#a22aa9d16f96c6693a4997b3c37d9c134">getElementOfJSONAppendedDoc</a></div><div class="ttdeci">std::vector&lt; std::string &gt; getElementOfJSONAppendedDoc(std::string JSONDocs)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:169</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a7ea64e50cd40d9c0b921a481e718740f"><div class="ttname"><a href="search_path_utilities_8hpp.html#a7ea64e50cd40d9c0b921a481e718740f">getElementPairsOfJSONArray</a></div><div class="ttdeci">std::vector&lt; std::pair&lt; std::string, std::string &gt; &gt; getElementPairsOfJSONArray(std::string JSONarray)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:190</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a4731041361b0df9f731e6f0d9dcb2037"><div class="ttname"><a href="search_path_utilities_8hpp.html#a4731041361b0df9f731e6f0d9dcb2037">cutleadingNtrailingPattern</a></div><div class="ttdeci">std::string cutleadingNtrailingPattern(std::string search_path, std::string pattern)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:37</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a6eaa9e7803d69414d32130fee3c26789"><div class="ttname"><a href="search_path_utilities_8hpp.html#a6eaa9e7803d69414d32130fee3c26789">createTargetFilePath</a></div><div class="ttdeci">std::vector&lt; std::string &gt; createTargetFilePath(std::string sourceFileJson)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:274</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a3a886e5cb3ce1bb6064aeac57f547f72"><div class="ttname"><a href="search_path_utilities_8hpp.html#a3a886e5cb3ce1bb6064aeac57f547f72">getIdentificationStruct</a></div><div class="ttdeci">ident_type getIdentificationStruct(std::vector&lt; std::string &gt; cur_vec, std::string key)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:412</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a05bc4046e38ba530ba7c938105aed5a4"><div class="ttname"><a href="search_path_utilities_8hpp.html#a05bc4046e38ba530ba7c938105aed5a4">checkNcreateDirectories</a></div><div class="ttdeci">void checkNcreateDirectories(std::string targetFile, std::string sourceFileFullPath)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:239</div></div>
<div class="ttc" id="astructident__type_html"><div class="ttname"><a href="structident__type.html">ident_type</a></div><div class="ttdef"><b>Definition:</b> resolveInterfaceVariables.hpp:70</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_ac3caf8cc2926982436bf403dc2acec8a"><div class="ttname"><a href="search_path_utilities_8hpp.html#ac3caf8cc2926982436bf403dc2acec8a">splitTokens</a></div><div class="ttdeci">void splitTokens(const std::string &amp;str, std::vector&lt; std::string &gt; &amp;cont, char delim)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:25</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a8053480525c9fdca9d9feabaf252b90c"><div class="ttname"><a href="search_path_utilities_8hpp.html#a8053480525c9fdca9d9feabaf252b90c">getSWUnitRef</a></div><div class="ttdeci">std::string getSWUnitRef(std::string MDX_methimpl)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:439</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a65385cf4429f17bcbd1f4e78c4d50259"><div class="ttname"><a href="search_path_utilities_8hpp.html#a65385cf4429f17bcbd1f4e78c4d50259">replaceString</a></div><div class="ttdeci">std::string replaceString(std::string search_path, std::string origin, std::string replacement)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:50</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a5b17eb6620c1c79a216b45cb08364b20"><div class="ttname"><a href="search_path_utilities_8hpp.html#a5b17eb6620c1c79a216b45cb08364b20">getElementOfJSONChainedDoc</a></div><div class="ttdeci">std::vector&lt; std::pair&lt; std::string, std::string &gt; &gt; getElementOfJSONChainedDoc(std::string JSONDocs)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:68</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a38a14ece7625a78b944e2fcdf17ef45b"><div class="ttname"><a href="search_path_utilities_8hpp.html#a38a14ece7625a78b944e2fcdf17ef45b">getElementOfJSONArray</a></div><div class="ttdeci">std::vector&lt; std::string &gt; getElementOfJSONArray(std::string JSONarray)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:216</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a6f7bdad1724b71001c5dd5c9b6d989bd"><div class="ttname"><a href="search_path_utilities_8hpp.html#a6f7bdad1724b71001c5dd5c9b6d989bd">createWorkingEnvironment</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; std::string &gt; &gt; createWorkingEnvironment()</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:338</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a35040d624bbaf96a0baf54d0fffd1f8b"><div class="ttname"><a href="search_path_utilities_8hpp.html#a35040d624bbaf96a0baf54d0fffd1f8b">getIdentificationOfObj</a></div><div class="ttdeci">ident_type getIdentificationOfObj(std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt; val_inner_vec, std::string key)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:386</div></div>
<div class="ttc" id="asearch_path_utilities_8hpp_html_a2d2bb888b17259ef2c9d363504c742db"><div class="ttname"><a href="search_path_utilities_8hpp.html#a2d2bb888b17259ef2c9d363504c742db">getDenominatorOrNumerator</a></div><div class="ttdeci">std::pair&lt; std::string, std::vector&lt; std::string &gt; &gt; getDenominatorOrNumerator(std::string MDX_methimpl)</div><div class="ttdef"><b>Definition:</b> searchPathUtilities.hpp:460</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="search_path_utilities_8hpp.html">searchPathUtilities.hpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
